# libsoc - Library to handle standardised output files
# Copyright (C) 2015 Rikard Nordgren
# 
# This file was autogenerated and should not be edited
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
# 
# his library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <http://www.gnu.org/licenses/>.

so_SOBlock_add_message <- function(type, toolname, name, content, severity) {
    if (isnull(.self$.cobj)) {
        stop(".cobj is NULL")
    }
    stopifnot(is(type, "character"), length(type) == 1)
    stopifnot(is(toolname, "character"), length(toolname) == 1)
    stopifnot(is(name, "character"), length(name) == 1)
    stopifnot(is(content, "character"), length(content) == 1)
    if (is(severity, "numeric")) {
        severity = as.integer(severity)
    }
    stopifnot(is(severity, "integer"), length(severity) == 1)
    invisible(.Call("R_so_SOBlock_add_message", .self$.cobj, type, toolname, name, content, severity))
}
so_SOBlock$methods(add_message = so_SOBlock_add_message)

so_SOBlock_add_rawresults_datafile <- function(description, path, oid) {
    if (isnull(.self$.cobj)) {
        stop(".cobj is NULL")
    }
    stopifnot(is(description, "character"), length(description) == 1)
    stopifnot(is(path, "character"), length(path) == 1)
    stopifnot(is(oid, "character"), length(oid) == 1)
    invisible(.Call("R_so_SOBlock_add_rawresults_datafile", .self$.cobj, description, path, oid))
}
so_SOBlock$methods(add_rawresults_datafile = so_SOBlock_add_rawresults_datafile)

so_SOBlock_add_rawresults_graphicsfile <- function(description, path, oid) {
    if (isnull(.self$.cobj)) {
        stop(".cobj is NULL")
    }
    stopifnot(is(description, "character"), length(description) == 1)
    stopifnot(is(path, "character"), length(path) == 1)
    stopifnot(is(oid, "character"), length(oid) == 1)
    invisible(.Call("R_so_SOBlock_add_rawresults_graphicsfile", .self$.cobj, description, path, oid))
}
so_SOBlock$methods(add_rawresults_graphicsfile = so_SOBlock_add_rawresults_graphicsfile)

so_SOBlock_all_simulated_profiles <- function() {
    if (isnull(.self$.cobj)) {
        stop(".cobj is NULL")
    }
    invisible(.Call("R_so_SOBlock_all_simulated_profiles", .self$.cobj))
}
so_SOBlock$methods(all_simulated_profiles = so_SOBlock_all_simulated_profiles)
