/* libsoc - Library to handle standardised output files
 * Copyright (C) 2015 Rikard Nordgren
 * 
 * This file was autogenerated and should not be edited
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * his library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _SO_PRIVATE_MESSAGE_H
#define _SO_PRIVATE_MESSAGE_H

#include <libxml/xmlwriter.h>


struct so_Message {
	char *type;
	char *Toolname;
	char *Name;
	char *Content;
	int *Severity;
	int Severity_number;
	int in_Toolname;
	int in_Name;
	int in_Content;
	int in_Severity;
	int reference_count;
};

int so_Message_start_element(so_Message *self, const char *localname, int nb_attributes, const char **attributes);
void so_Message_end_element(so_Message *self, const char *localname);
int so_Message_characters(so_Message *self, const char *ch, int len);
int so_Message_xml(so_Message *self, xmlTextWriterPtr writer);
int so_Message_init_attributes(so_Message *self, int nb_attributes, const char **attributes);

#endif
