/* libsoc - Library to handle standardised output files
 * Copyright (C) 2015 Rikard Nordgren
 * 
 * This file was autogenerated and should not be edited
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * his library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _SO_PRIVATE_MODELDIAGNOSTIC_H
#define _SO_PRIVATE_MODELDIAGNOSTIC_H

#include <libxml/xmlwriter.h>

#include <so/private/DiagnosticStructuralModel.h>
#include <so/private/DiagnosticIndividualParams.h>

struct so_ModelDiagnostic {
	so_DiagnosticStructuralModel *DiagnosticStructuralModel;
	so_DiagnosticIndividualParams *DiagnosticIndividualParams;
	int in_DiagnosticStructuralModel;
	int in_DiagnosticIndividualParams;
	int reference_count;
};

int so_ModelDiagnostic_start_element(so_ModelDiagnostic *self, const char *localname, int nb_attributes, const char **attributes);
void so_ModelDiagnostic_end_element(so_ModelDiagnostic *self, const char *localname);
int so_ModelDiagnostic_characters(so_ModelDiagnostic *self, const char *ch, int len);
int so_ModelDiagnostic_xml(so_ModelDiagnostic *self, xmlTextWriterPtr writer);

#endif
