/* libsoc - Library to handle standardised output files
 * Copyright (C) 2015 Rikard Nordgren
 * 
 * This file was autogenerated and should not be edited
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * his library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _SO_PRIVATE_OFMEASURES_H
#define _SO_PRIVATE_OFMEASURES_H

#include <libxml/xmlwriter.h>

#include <so/private/Table.h>
#include <so/private/InformationCriteria.h>

struct so_OFMeasures {
	double *Likelihood;
	double Likelihood_number;
	double *LogLikelihood;
	double LogLikelihood_number;
	double *Deviance;
	double Deviance_number;
	double *ToolObjFunction;
	double ToolObjFunction_number;
	so_Table *IndividualContribToLL;
	so_InformationCriteria *InformationCriteria;
	int in_Likelihood;
	int in_LogLikelihood;
	int in_Deviance;
	int in_ToolObjFunction;
	int in_IndividualContribToLL;
	int in_InformationCriteria;
	int reference_count;
};

int so_OFMeasures_start_element(so_OFMeasures *self, const char *localname, int nb_attributes, const char **attributes);
void so_OFMeasures_end_element(so_OFMeasures *self, const char *localname);
int so_OFMeasures_characters(so_OFMeasures *self, const char *ch, int len);
int so_OFMeasures_xml(so_OFMeasures *self, xmlTextWriterPtr writer);

#endif
