/* libsoc - Library to handle standardised output files
 * Copyright (C) 2015 Rikard Nordgren
 * 
 * This file was autogenerated and should not be edited
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * his library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _SO_PRIVATE_OTHERMETHOD_PPE_H
#define _SO_PRIVATE_OTHERMETHOD_PPE_H

#include <libxml/xmlwriter.h>

#include <so/private/Matrix.h>
#include <so/private/Table.h>

struct so_OtherMethod_PPE {
	so_Matrix *CovarianceMatrix;
	so_Matrix *CorrelationMatrix;
	so_Table *StandardDeviation;
	so_Table *StandardError;
	so_Table *AsymptoticCI;
	so_Table *PercentilesCI;
	int in_CovarianceMatrix;
	int in_CorrelationMatrix;
	int in_StandardDeviation;
	int in_StandardError;
	int in_AsymptoticCI;
	int in_PercentilesCI;
	int reference_count;
};

int so_OtherMethod_PPE_start_element(so_OtherMethod_PPE *self, const char *localname, int nb_attributes, const char **attributes);
void so_OtherMethod_PPE_end_element(so_OtherMethod_PPE *self, const char *localname);
int so_OtherMethod_PPE_characters(so_OtherMethod_PPE *self, const char *ch, int len);
int so_OtherMethod_PPE_xml(so_OtherMethod_PPE *self, xmlTextWriterPtr writer);

#endif
