/* libsoc - Library to handle standardised output files
 * Copyright (C) 2015 Rikard Nordgren
 * 
 * This file was autogenerated and should not be edited
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * his library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _SO_PRIVATE_POPULATIONESTIMATES_H
#define _SO_PRIVATE_POPULATIONESTIMATES_H

#include <libxml/xmlwriter.h>

#include <so/private/Table.h>
#include <so/private/Bayesian.h>
#include <so/private/OtherMethod.h>

struct so_PopulationEstimates {
	so_Table *MLE;
	so_Bayesian *Bayesian;
	so_OtherMethod *OtherMethod;
	int in_MLE;
	int in_Bayesian;
	int in_OtherMethod;
	int reference_count;
};

int so_PopulationEstimates_start_element(so_PopulationEstimates *self, const char *localname, int nb_attributes, const char **attributes);
void so_PopulationEstimates_end_element(so_PopulationEstimates *self, const char *localname);
int so_PopulationEstimates_characters(so_PopulationEstimates *self, const char *ch, int len);
int so_PopulationEstimates_xml(so_PopulationEstimates *self, xmlTextWriterPtr writer);

#endif
