/* libsoc - Library to handle standardised output files
 * Copyright (C) 2015 Rikard Nordgren
 * 
 * This file was autogenerated and should not be edited
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * his library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _SO_PRIVATE_RAWRESULTS_H
#define _SO_PRIVATE_RAWRESULTS_H

#include <libxml/xmlwriter.h>

#include <so/private/Table.h>
#include <so/private/ExternalFile.h>

struct so_RawResults {
	so_Table **DataFile;
	so_ExternalFile **GraphicsFile;
	int num_DataFile;
	int num_GraphicsFile;
	int in_DataFile;
	int in_GraphicsFile;
	int reference_count;
};

int so_RawResults_start_element(so_RawResults *self, const char *localname, int nb_attributes, const char **attributes);
void so_RawResults_end_element(so_RawResults *self, const char *localname);
int so_RawResults_characters(so_RawResults *self, const char *ch, int len);
int so_RawResults_xml(so_RawResults *self, xmlTextWriterPtr writer);

#endif
