/* libsoc - Library to handle standardised output files
 * Copyright (C) 2015 Rikard Nordgren
 * 
 * This file was autogenerated and should not be edited
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * his library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _SO_PRIVATE_TASKINFORMATION_H
#define _SO_PRIVATE_TASKINFORMATION_H

#include <libxml/xmlwriter.h>

#include <so/private/Message.h>
#include <so/private/ExternalFile.h>

struct so_TaskInformation {
	so_Message **Message;
	so_ExternalFile **OutputFilePath;
	double *RunTime;
	double RunTime_number;
	int *NumberChains;
	int NumberChains_number;
	int *NumberIterations;
	int NumberIterations_number;
	int num_Message;
	int num_OutputFilePath;
	int in_Message;
	int in_OutputFilePath;
	int in_RunTime;
	int in_NumberChains;
	int in_NumberIterations;
	int reference_count;
};

int so_TaskInformation_start_element(so_TaskInformation *self, const char *localname, int nb_attributes, const char **attributes);
void so_TaskInformation_end_element(so_TaskInformation *self, const char *localname);
int so_TaskInformation_characters(so_TaskInformation *self, const char *ch, int len);
int so_TaskInformation_xml(so_TaskInformation *self, xmlTextWriterPtr writer);

#endif
